import numpy as np
import sys
sys.path.append('/home/fs01/se237/lib/python')
import scipy as sc
from scipy.sparse import coo_matrix
from scipy.optimize import fmin_l_bfgs_b
import math
import re
import locale
#import LangDet
from scipy.io import mmread, mmwrite
from guess_language import (guessLanguage, guessLanguageName, guessLanguageTag, guessLanguageId, guessLanguageInfo)

def word_overlap(a, b):
    return [x for x in a if x in b]

def jaccard(a, b, overlap_fn=word_overlap):
    """
    Jaccard coefficient (/\ represents intersection), given by :
    	Jaccard(A, B) = (A /\ B) / (|a|) + (|b|) - (A /\ B)
    """
    c = overlap_fn(a, b)
    return float(len(c)) / (len(a) + len(b) - len(c))

	
# column to be optimized
i= int(sys.argv[3])

## length of the horizon
horizon = 304

## dffusion mode
type_diffusion = "exp"

infile = sys.argv[1]		# sys.argv[2]
num_nodes = int(sys.argv[2])	
			
split_cascades = False


use_language = False
use_additional_features = False

debug_opt_sol = False

remove_duplicates = False

print_cascades = False


# gtruthfilename = "./%d_ground_truth" % frac_perc
# infile3 = "./user_id"
# infile1 = "./%d_cascade_name" % frac_perc	
# baseTweetsFolder = ("./%d_" % frac_perc) + "cascade_tweet"
gtruthfilename =sys.argv[4]
	
if (use_language or use_additional_features):			
	infile3 = sys.argv[5]
	infile1 = sys.argv[6]
	baseTweetsFolder = sys.argv[7]


# read in cascades
num_cascades = [0] *num_nodes				# number of times node i appears in a cascade
num_actv_cascades = [0] *num_nodes			# number of times node i appears in a cascade

print "Reading cascades from " + infile	
C=[]	
cascfile = open(infile, "r")
flag = 0
ind = 0
for l in cascfile:
	#print ind
	ind = ind + 1
	#print flag
	if ((flag>0) & (len(l)>1)):	
		num_inside_cascades = [0] *num_nodes			# number of times node i appears inside a cascade
		#print l
		spl = l.split(',')
		casc = []
		for j in xrange(0,len(spl),3):
			if (not (remove_duplicates and num_actv_cascades[int(spl[j])]>0)):
				casc.append([int(spl[j]), float(spl[j+2]), int(spl[j+1])])
				num_cascades[int(spl[j])] = num_cascades[int(spl[j])] + 1
				num_inside_cascades[int(spl[j])] = num_inside_cascades[int(spl[j])] + 1
				if ((not split_cascades) & (j>0)):
					num_actv_cascades[int(spl[j])] = num_actv_cascades[int(spl[j])] + 1
				else:
					if ((j>0) & (int(spl[j-3])!=i)):
						num_actv_cascades[int(spl[j])] = num_actv_cascades[int(spl[j])] + 1
		if (len(casc)>1):
			C.append(casc)
	if len(l)== 1:		# empty line
		flag = 1		
cascfile.close()

		

	
if (use_language or use_additional_features):

	userfile = open(infile3, "r")	
	map = {}
	for l in userfile:
		spl = l.split(' ')
		map[spl[0]]=int(spl[1])
	
	# threshold parameter
	#i= int(sys.argv[1])
	fileencoding = "utf-8"
	# read in hashtag
	print "Building features. Reading Hashtags..."	

	hashfile = open(infile1, "r")
	language, output_encoding = locale.getdefaultlocale()
	Tweets=[]
	TweetsLangs=[]
	idx = 0
	for l in hashfile:
		HashTweets = []
		HashLangs = []
		if len(l) > 1:	# not an empty line (hashtag)
			txt = l.decode(fileencoding)
			pattern = re.compile("#(\S+)\.", re.UNICODE)
			tmp = re.search(pattern, txt)
			found = txt[tmp.start():tmp.end()]
			outs = found.encode(output_encoding,"replace")
			#print outs 
			#infile2 = ("./%d_" % frac_perc) + ("cascade_tweet/tweet_%s" % txt[tmp.start():tmp.end()-1])
			infile2 = baseTweetsFolder + ("/tweet_%s" % txt[tmp.start():tmp.end()-1])
			cascfile = open(infile2, "r")
			stidx = 0
			userid = C[idx][stidx][2]
			for c in cascfile:
				if len(c)>2:
					spl = c.split(' ')
					tweet = ''
					tweetL = ''
					if spl[0] in map:
						#print spl[0]
						#print "st" + str(userid)
						userid = C[idx][stidx][2]
						if userid != map[spl[0]]:
							print "ERROR!" + spl[0] + " " + str(userid) + " " +str(map[spl[0]])
						for j in xrange(2,len(spl),1):
							tweet = tweet +' ' +spl[j]
							if (not (spl[j].startswith('http://') or spl[j].startswith('#') or spl[j].startswith('@') or spl[j].startswith('RT'))):
								tweetL = tweetL +' ' +spl[j]
						HashTweets.append(tweet)
						#if len(HashTweets)<5:
						#	print HashTweets
						if use_language:							
							HashLangs.append(guessLanguageId(tweetL))
							#HashLangs.append(ld.detect(tweetL))
						stidx = stidx +1
						
			idx = idx+1			
			Tweets.append(HashTweets)
			#print len(HashTweets)
			#print "C="+str(len(C[idx]))
			if use_language:
				TweetsLangs.append(HashLangs)
	hashfile.close()

if use_additional_features:
	JSM = []			# jaccard similarity matrixes
	print "total number of hashtags" + str(len(Tweets))
	print "total number of cascades" + str(len(C))
	for c in  range(len(Tweets)):
		print c
		try:
			cascfile = open("./FeaturesMatrix/Casc" + str(c)+".J", "r")
			J = sc.genfromtxt("./FeaturesMatrix/Casc" + str(c)+".J")
			#J = mmread("./FeaturesMatrix/Casc" + str(c)+".J")
			JSM.append(J)
		except IOError as e:
			J = sc.array([[0.0] *len(C[c])]*len(C[c]))
			#J = sc.sparse.lil_matrix((len(C[c]),len(C[c])))
			#print Tweets[c][0]
			#print Tweets[c][1]
			for k in range(len(C[c])):
				for f in range(len(C[c])):
					jac = jaccard(Tweets[c][k].split(),Tweets[c][f].split())
					if jac>0:
						J[k,f] = jac
					#if J[k,f]>0:
					#	print J[k,f]
			JSM.append(J)
			#sc.savetxt("./FeaturesMatrix/Casc" + str(c)+".J",J)
			#mmwrite("./FeaturesMatrix/Casc" + str(c)+".J",J)

##############################################
##############################################


A_bad = sc.sparse.lil_matrix((num_nodes,num_nodes))
A_potential = sc.sparse.lil_matrix((num_nodes,num_nodes))

print "Computing APotential and Abad"	
for c in range(len(C)):
	#print len(C[c])
	belongsFlag = False
	for k in range(len(C[c])):
		if C[c][k][0]==i:							# just compute the column we need
			belongsFlag = True
			if split_cascades:			
				j = k-1
				while ((j>=0) & (C[c][j][0]!=C[c][k][0])):
					delta = C[c][k][1]-C[c][j][1]
					if delta==0:
						delta = 0.0000001
					if type_diffusion=="exp":
						additional_term = 0.0
						A_potential[C[c][j][0], C[c][k][0]] = A_potential[C[c][j][0], C[c][k][0]] + delta +additional_term
					elif type_diffusion=="rayleigh":
						A_potential[C[c][j][0], C[c][k][0]] = A_potential[C[c][j][0], C[c][k][0]] + math.pow(delta,2)/2.0
					else:
						print "unsupported"
					j = j -1
			else:
				for j in range(k):
					delta = C[c][k][1]-C[c][j][1]
					if type_diffusion=="exp":
						additional_term = 0.0
						A_potential[C[c][j][0], C[c][k][0]] = A_potential[C[c][j][0], C[c][k][0]] + delta+ additional_term
					elif type_diffusion=="rayleigh":
						A_potential[C[c][j][0], C[c][k][0]] = A_potential[C[c][j][0], C[c][k][0]] + math.pow(delta,2)/2.0
					else:
						print "unsupported"
	# compute A_bad
	j = i
	if (not belongsFlag):
		for k in xrange(0,len(C[c]),1):
			if type_diffusion=="exp":
				additional_term = 0.0
				A_bad[C[c][k][0], j] = A_bad[C[c][k][0], j] + (horizon-C[c][k][1]) + additional_term
			elif type_diffusion=="rayleigh":
				A_bad[C[c][k][0], j] = A_bad[C[c][k][0], j] +math.pow(C[c][k][1]-horizon,2)/2.0
			else:
				print "unsupported"
				

print "Node " + str(i) + " is active " + str(num_actv_cascades[i]) + " times"
print "Building Coefficients"	
# build coefficients
c_act = 0
al=[]
B = sc.array([[0.0] *num_nodes]* num_actv_cascades[i])			# sparse
for c in range(len(C)):
	idx = []
	temp = 0
	coeffm = sc.zeros((1,num_nodes))	
	timem = sc.zeros((1,num_nodes))
	test = [0] *num_nodes
	szcount = 0
	for k in range(len(C[c])):
		if C[c][k][0]!=i:
			szcount = szcount +1			
		else:			# found i
			if szcount>0:		# not the first element
				j = k-1
				while ((split_cascades and C[c][j][0]!=i and j>=0) or ((not split_cascades) and j>=0)):
					if type_diffusion=="exp":
						term = 1.0
					elif type_diffusion=="rayleigh":
						term = C[c][k][1]-C[c][j][1]
					else:
						print "unsupported"
					if use_additional_features:		
						term = term* math.pow(2,-32*(1-JSM[c][k,j]))	
					if (use_language and TweetsLangs[c][k]!=TweetsLangs[c][j]):
						term = term* 0.5
					if (C[c][j][0]!=i):
						coeffm[0,C[c][j][0]] = coeffm[0,C[c][j][0]] + term
					j = j-1
			
				B[c_act,:]=coeffm[0,:]
				c_act = c_act + 1
				coeffm = sc.zeros((1,num_nodes))	
				if split_cascades:			
				#timem = sc.zeros((1,num_nodes))
					szcount = 0


print "Size of B vs. activity " + str((B.shape[0],num_actv_cascades[i]))

scale = 1.0


def func(a_hat):
	obj = 0.0
	grad = sc.array(([0.0] * num_nodes))
	if num_cascades[i]>0:		
		for j in range(num_nodes):
			if (A_potential[j,i] > 0):
				obj = -a_hat[j]*(A_potential[j,i] + A_bad[j,i])/scale + obj				
				# update grad
				grad[j] = -(A_potential[j,i] + A_bad[j,i])/scale
		
		y = sc.dot(B,a_hat)
		#print y
		qq = obj
		
		for c in range(c_act):
			obj = obj+sc.log(y[c])
			for j in range(num_nodes):
				if B[c][j]>0:
					grad[j] = grad[j] + B[c,j]/y[c]
	
		#print 'obj = ' , -obj, 'prev term =', qq
	
	return -obj,-grad

guess = [0.1] * num_nodes	
try:
   cascfile = open("OptCol" + str(i) + ".txt", "r")
   print "Reading initial guess"
   z = 0
   for l in cascfile:
		guess[z] = float(l)		
		z = z +1
except IOError as e:
   print "guessing"
   
# force elements to be zero   
for j in range(num_nodes):
	if (A_potential[j,i] == 0):
		guess[j] = 0.000001


Adjmatrix = sc.sparse.lil_matrix((num_nodes,num_nodes))
cascfile = open(gtruthfilename, "r")
z = 0
for l in cascfile:
	spl = l.split(' ')
	Adjmatrix[int(spl[0]), int(spl[1])] = 1
cascfile.close()

bounds =[]
for j in range(num_nodes):
	if (debug_opt_sol):
		if Adjmatrix[j,i]==1:					# force positive
			bounds.append((0.00001,None))
		else:
			bounds.append((0.000001,None))
	else:
		bounds.append((0.000001,None))
	
best, val, d = sc.optimize.fmin_l_bfgs_b(func, guess, bounds=bounds, iprint=2, m=10, maxfun=10000)

print 'Minimum ',best, ' and its value',val
	
for j in range(num_nodes):
	if (A_potential[j,i] == 0):
		best[j] = 0.000001

		
# write solution to disk
resout = open("OptCol" + str(i) + ".txt",'w')
for j in range(num_nodes):
	resout.write(str(best[j])+'\n')
	
# read ground truth and compute precision recall
print "Computing Precision/Recall"	

tp = 0
fp = 0
fn = 0
b1 = 0

for j in range(num_nodes):
	if best[j]>=0.00001:
		if Adjmatrix[i,j]==1:
			tp = tp + 1
		else:
			fp = fp + 1
	else:
		if Adjmatrix[i,j]==1:
			fn = fn +1
	if (A_potential[j,i] >0 and Adjmatrix[i,j]==1):
		b1 =  b1 +1
print "True positives " + str(tp)
print "False positives " + str(fp)
print "False neg " + str(fn)
if (tp+fn>0 and tp+fp>0):
	print "Precision: " + str((tp+0.0)/(tp+fp)) + "/ Recall: " + str((tp+0.0)/(tp+fn))